
#ifndef SECQSOWIDS_H
#define SECQSOWIDS_H

#include "GUI.h"
#include "twpskScope.h"

class DecoderWid {
   private:
      int i;
      int rxScrollFlag;
      int hasfocus;
      Arg args[30];
      char str[64];
      Scope dscope;
      float curfreq;

      Widget dialogShell;
      Widget   mainForm;
      Widget     rxTextSW;
      Widget       rxScrollBar;
      Widget       rxText;
      Widget   bottomForm;
      Widget     scopeDA;
      Widget   rxFreqCombo;
      Widget   pbForm;
      Widget      swapBtn, closeBtn;
      Widget AFCwid, DCDwid, QPSKwid;
      Widget modeForm;
      Widget clrRxPopup;
      XmString xs[5];


 public:
   void setFreqFocus(int v)
    {
      hasfocus=v;
    }

   Widget getRxText ()
   {
      return rxText;
   }

   void setRxScrollFlag(int f)
   {
      rxScrollFlag = f;
   }

   int getRxScrollFlag ()
   {
      return (rxScrollFlag);
   }

#if 0
   int getLSB()
   {
      int value;
      XtVaGetValues(LSBwid, XmNset, &value, NULL);
      return value;
    }

   void setLSB(int value)
   {
      XtVaSetValues(LSBwid, XmNset, value, NULL);
   }
#endif

   int getQPSK()
   {
      int value;
      XtVaGetValues(QPSKwid, XmNset, &value, NULL);
      return value;
   }

   void setQPSK(int value)
   {
      XtVaSetValues(QPSKwid, XmNset, value, NULL);
   }

   int getAFC()
   {
      int value;
      XtVaGetValues(AFCwid, XmNset, &value, NULL);
      return value;
   }

   void setAFC(int value)
   {
      XtVaSetValues(AFCwid, XmNset, value, NULL);
   }

   void setControls(int QPSK, int /*LSB*/, int AFC)
   {
      setQPSK(QPSK);
      //setLSB(LSB);
      setAFC(AFC);
   }

   void setFreq(float freq)
   {
      curfreq = freq;
      //fprintf(stderr,"dw: set: %f\n",freq);
      sprintf(str, "%6.1f", freq);
      XmTextFieldSetString (rxfreqwid, str);
      commControl(commChannel, COMM_FREQ, (int)(freq*100));
      }

   float getFreq()
   {
      String str;
      XtVaGetValues (rxfreqwid, XmNvalue, &str, NULL);  /* Get the freq */
      float f = atof(str);                        /* convert to a float */
      //fprintf(stderr,"dw: get: %f\n",f);
      return f;
   }

   DecoderWid()
   {
      visible=0;
      hasfocus=0;
   }

   Widget rxfreqwid, rxUpArrow, rxDownArrow;
   int visible;
   int commChannel;
   static Widget shell;
   void move(int x, int y);
   Scope& getScope() { return dscope; };
   Widget getTextWid() { return rxText; };
   Widget getMainWid() { return dialogShell; };
   Widget getSwapBtn() { return swapBtn; }
   void buildWidgets(Widget shell, AppRes *appRes);
   void updateDisplay(float freq, int DCD, int IMD);
};


#define MAX_DECODERS 3
extern DecoderWid decoderWids[MAX_DECODERS];

#endif
