/* twpsk  - A gui application for PSK
 * Copyright (C) 1999 Ted Williams WA0EIR (ted@bluestone.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Version: 1.1 - Aug 2000
 */


/*
 * aboutDiag Function - Just an info dialog
 *
 */

#include "GUI.h"
extern AppRes appRes;

void aboutCB (Widget w, XtPointer widget, XtPointer cbdata)
{
   static Widget diag = NULL;
   Widget shell = (Widget) widget;
   XmString  msg_xs;
   char msg_str[] =
 "twpsk \251 2000\n\nInterfaces written by Ted Williams    - WA\330EIR
PSK classes writen by Hansi Reiser - DL9RDZ";

   if (diag == NULL)
      {
      diag = XmCreateInformationDialog (shell, "aboutDiag",  (ArgList) NULL, 0);
      XtVaSetValues (XtParent(diag),
         XmNtitle, "ABOUT TWPSK",
         XmNmwmDecorations, MWM_DECOR_ALL | MWM_DECOR_RESIZEH,
         NULL);

      msg_xs = XmStringCreateLtoR (msg_str, XmFONTLIST_DEFAULT_TAG);
      XtVaSetValues (diag,
         XmNmessageAlignment, XmALIGNMENT_CENTER,
         XmNmessageString, msg_xs,
         NULL);
      XmStringFree(msg_xs);

      XtUnmanageChild (XmMessageBoxGetChild (diag, XmDIALOG_CANCEL_BUTTON));
      XtUnmanageChild (XmMessageBoxGetChild (diag, XmDIALOG_HELP_BUTTON));
      }
   XtManageChild (diag);
}


/*
 * inputDiag - used to enter text at an "*" when sending a file
 */
void inputDiag (Widget shell, char *word)
{
   Widget promptDiag;
   XmString msg_xs;
   XmString textField;

      promptDiag = XmCreatePromptDialog (shell, "promptDiag", (ArgList) NULL, 0);
      XtUnmanageChild (XmSelectionBoxGetChild (promptDiag, XmDIALOG_HELP_BUTTON));
      XtUnmanageChild (XmSelectionBoxGetChild (promptDiag, XmDIALOG_CANCEL_BUTTON));
//      XtAddCallback (promptDiag, XmNokCallback, OkCB, (XtPointer) NULL);

   XtVaSetValues (XtParent (promptDiag),
      XmNtitle, "TWPSK Prompt Dialog",
      XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
      NULL);

   msg_xs = XmStringCreateLocalized (word);
   textField = XmStringCreateLocalized ("");

   XtVaSetValues (promptDiag,
      XmNmessageAlignment, XmALIGNMENT_CENTER,
      XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
      XmNtextString, textField,
      XmNselectionLabelString, msg_xs,
      NULL); 

   XmStringFree (msg_xs);
   XmStringFree (textField);
   XtManageChild (promptDiag);
}


/*
 * Cancel Callback for promptDiag
 */
/*
 *void cancelCB (Widget w, XtPointer cldata, XtPointer cbdata)
 *{
 *   XtAppAddWorkProc (ac, procData, (XtPointer) NULL);
 *}
 */


/*
 * helpCB - help dialog callback
 * helpfile is keep in /usr/share/psk31
 */

void helpCB (Widget w, XtPointer wid, XtPointer call_data)
{
Widget shell = (Widget)wid;
static Widget helpDiag=NULL;
static Widget helpTxt = NULL;
char *filepath = "/usr/share/psk31/twpskHelp";
char *textpt;

   if (helpDiag == NULL)
   {
      textpt = getFile (filepath);              /* Read the help file */

      helpDiag = XmCreateInformationDialog(shell, "helpDiag", NULL, 0);
      XtVaSetValues (XtParent(helpDiag),
         XmNtitle, "TWPSK HELP FILE",
         NULL);
      XtUnmanageChild (XmMessageBoxGetChild (helpDiag, XmDIALOG_CANCEL_BUTTON));
      XtUnmanageChild (XmMessageBoxGetChild (helpDiag, XmDIALOG_HELP_BUTTON));

      helpTxt = XmCreateScrolledText (helpDiag, "helpTxt", NULL, 0);
      XtVaSetValues (helpTxt,
         XmNcolumns, 80,
         XmNmargin, 10,
         XmNrows, 10,
         XmNvalue, textpt,
         XmNeditMode, XmMULTI_LINE_EDIT,
         XmNeditable, False,
         XmNresizeWidth, True,
         XmNautoShowCursorPosition, False,
         XmNcursorPositionVisible, False,
         NULL);
      XtManageChild (helpTxt);
   }
   XtManageChild (helpDiag);
}

/*
 * getFile Function
 * Passed a pathname, this malloc's space for the file
 * reads the file, and returns a pointer to the file contents.
 * The pointer must be freed!
 */
char *getFile (char *filename)
{
   FILE *fp;
   struct stat info;
   char *pt;
   if (stat (filename, &info) != 0)
   {
       perror ("File Stat");
       exit (1);
   }

   if ((pt = (char *)XtMalloc ((int)info.st_size + 1)) == NULL)
   {
       perror ("twpskDiags getFile - Xtmalloc error");
       exit (1);
   }

   if ((fp = fopen (filename, "r")) == NULL)   
   {
       perror ("twpskDiags getFile - File Open error");
       exit (1);
   }

   if (fread (pt, 1, info.st_size, fp) != (unsigned int)(info.st_size))
   {
       perror ("twpskDiags getFile - Read error");
       exit (1);
   }  
   pt[info.st_size] = '\0';
   return (pt);
} 
